# geos::index::quadtree::NodeBase Class Reference

The base class for nodes in a Quadtree. More...

`#include <NodeBase.h>`

Inheritance diagram for geos::index::quadtree::NodeBase:

List of all members.

## Public Member Functions

virtual std::vector< void * > * | getItems ()
virtual void | add (void *item)
virtual std::vector< void * > * | addAllItems (std::vector< void * > *resultItems)
virtual void | addAllItemsFromOverlapping (const geom::Envelope *searchEnv, std::vector< void * > *resultItems)
virtual int | depth ()
virtual int | size ()
virtual int | nodeCount ()
virtual std::string | toString () const
virtual void | visit (const geom::Envelope *searchEnv, ItemVisitor &visitor)
bool | remove (const geom::Envelope *itemEnv, void *item)
bool | hasItems () const
bool | hasChildren () const
bool | isPrunable () const

## Static Public Member Functions

static int | getSubnodeIndex (const geom::Envelope *env, const geom::Coordinate &centre)

## Protected Member Functions

virtual bool | isSearchMatch (const geom::Envelope *searchEnv)=0

## Protected Attributes

std::vector< void * > * | items
Node * | subnode [4]

## Detailed Description

The base class for nodes in a Quadtree.

## Member Function Documentation

bool geos::index::quadtree::NodeBase::remove | ( | const geom::Envelope * | itemEnv,
|  | void * | item |
| ) |  |  |

Removes a single item from this subtree.

Parameters:

  | searchEnv | the envelope containing the item
  | item | the item to remove

Returns:
  `true` if the item was found and removed

## Member Data Documentation

Node* geos::index::quadtree::NodeBase::subnode[4]`[protected]`

subquads are numbered as follows:

      2 | 3
      --+--
      0 | 1

The documentation for this class was generated from the following file:

- quadtree/NodeBase.h